#
# Conditional build:
%bcond_without	doc		# build without doc
%bcond_without	tests		# build without tests

%define		orgname		extra-cmake-modules
%define		kdeframever	5.113
Summary:	Extra Cmake Modules for KF5
Summary(pl.UTF-8):	Dodatkowe moduły Cmake'a dla KF5
Name:		kf5-%{orgname}
Version:	5.113.0
Release:	1
License:	BSD
Group:		Development/Building
Source0:	https://download.kde.org/stable/frameworks/%{kdeframever}/%{orgname}-%{version}.tar.xz
# Source0-md5:	f037747c7a56fbbb64adb14d1f46fe5f
Patch0:		%{orgname}-tests.patch
Patch1:		kdefetchtranslations-test.patch
Patch2:		no-fatal-warnings.patch
URL:		https://kde.org/
BuildRequires:	cmake >= 3.16
BuildRequires:	qt5-assistant >= 5.9.0
BuildRequires:	qt5-linguist
BuildRequires:	rpmbuild(macros) >= 1.698
BuildRequires:	sed >= 4.0
%{?with_doc:BuildRequires:	sphinx-pdg >= 1.2}
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
%if %{with tests}
BuildRequires:	Qt5Core-devel >= 5.9.0
BuildRequires:	Qt5Quick-devel >= 5.9.0
BuildRequires:	libstdc++-devel >= 6:5
%endif
BuildConflicts:	qmake
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Extra CMake Modules package, or ECM, adds to the modules provided
by CMake, including both ones used by find_package() to find common
software and ones that can be used directly in CMakeLists.txt files to
perform common tasks.

In addition, it provides common build settings used in software
produced by the KDE community.

While the driving force of this module is to reduce duplication in
CMake scripts across KDE software, it is intended to be useful for any
software that uses the CMake build system.

%description -l pl.UTF-8
Pakiet Extra CMake Modules (ECM) dostarcza dodatkowe moduły do tych
dostarczanych przez CMake'a, zawierające te używane przez
find_package() do szukania popularnego oprogramowania, a także takie,
których można używać bezpośrednio w CMakeLists.txt do wykonywania
wspólnych zadań.

Ponadto pakiet dostarcza wspólne ustawienia budowana używane w
oprogramowaniu tworzonym przez społeczność KDE.

O ile główną motywacją tego modułu jest zmniejszenie duplikacji w
skryptach CMake'a w oprogramowaniu KDE, ma także być przydatny dla
dowolnych programów wykorzystujących system budowania CMake.

%package apidocs
Summary:	API documentation for %{orgname}
Summary(pl.UTF-8):	Dokumentacja API %{orgname}
Group:		Documentation
Obsoletes:	kf5-extra-cmake-modules-doc < 1.4.0

%description apidocs
API documentation for %{orgname}.

%description apidocs -l pl.UTF-8
Dokumentacja API dla %{orgname}.

%prep
%setup -q -n %{orgname}-%{version}
%patch0 -p1
%patch1 -p0
%patch2 -p1

# causes make install failure after running tests
%{__sed} -i -e '/ECMToolchainAndroidTest/d' tests/CMakeLists.txt

%build
%cmake -B build \
	%{!?with_tests:-DBUILD_TESTING=OFF} \
	%{!?with_doc:-DBUILD_HTML_DOCS=OFF}

%{__make} -C build

%if %{with tests}
# GenerateSipBindings wants clang and has libclang checks incompatible with libclang >= 4
# ECMPoQmToolsTest fails to build it's own moc file
cd build
ctest -E '(GenerateSipBindings|ECMPoQmToolsTest)' --output-on-failure
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build -j1 install \
        DESTDIR=$RPM_BUILD_ROOT

sed -i -e 's#/usr/bin/env bash#/bin/bash#' $RPM_BUILD_ROOT%{_datadir}/ECM/kde-modules/kde-git-commit-hooks/pre-commit.in
sed -i -e 's#/usr/bin/env bash#/bin/bash#' $RPM_BUILD_ROOT%{_datadir}/ECM/kde-modules/kde-git-commit-hooks/clang-format.sh

%if %{with doc}
%{__mv} $RPM_BUILD_ROOT%{_docdir}/ECM ECM-doc
%endif
install -d $RPM_BUILD_ROOT%{_datadir}/qlogging-categories5

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYING-CMAKE-SCRIPTS README.rst
%{_datadir}/ECM
%{_datadir}/qlogging-categories5
%{_mandir}/man7/ecm*.7*

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc ECM-doc/html/*
%endif
%changelog
* Sat Dec 16 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/kf5-extra-cmake-modules.git;a=log;h=master

* Fri Dec 15 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 6aa6db4
- updated to 5.113.0

* Mon Nov 13 2023 Witold Filipczyk <witekfl@poczta.onet.pl> da3a8e9
- updated to 5.112.0

* Thu Oct 19 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 1b4235a
- updated to 5.111.0

* Sun Sep 10 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 6503069
- updated to 5.110.0

* Fri Aug 18 2023 Witold Filipczyk <witekfl@poczta.onet.pl> b4c82a7
- cd build (no idea how to run ctest without chdir)

* Fri Aug 18 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 5f2ce10
- updated to 5.109.0; cmake -B build

* Sun Jul 09 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 5fc5735
- updated to 5.108.0

* Sun Jun 11 2023 Witold Filipczyk <witekfl@poczta.onet.pl> b050248
- updated to 5.107.0

* Sun May 14 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 4208379
- updated to 5.106.0

* Sun Apr 09 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 5397fc6
- updated to 5.105.0

* Sun Apr 09 2023 Krzysztof Mrozowicz <mrozowik@pld-linux.org> ce5ce6f
- rebuild against QT 5.15.9

* Mon Mar 13 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 52e8ef7
- updated to 5.104.0

* Sun Feb 12 2023 Witold Filipczyk <witekfl@poczta.onet.pl> 828a1f9
- updated to 5.103.0

* Mon Jan 16 2023 Witold Filipczyk <witekfl@poczta.onet.pl> b47dc96
- updated to 5.102.0

* Thu Jan 05 2023 Krzysztof Mrozowicz <mrozowik@pld-linux.org> cb965c8
- rebuild against QT 5.15.8

* Sat Dec 10 2022 Witold Filipczyk <witekfl@poczta.onet.pl> 5cc3e9a
- updated to 5.101.0

* Tue Nov 15 2022 Witold Filipczyk <witekfl@poczta.onet.pl> abf1e9a
- updated to 5.100.0

* Thu Nov 10 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> f9d9680
- rebuild against QT 5.15.7

* Mon Oct 10 2022 Witold Filipczyk <witekfl@poczta.onet.pl> 1849209
- updated to 5.99.0

* Mon Sep 12 2022 Witold Filipczyk <witekfl@poczta.onet.pl> 13570c6
- updated to 5.98.0

